#! /bin/sh
HOME_DIR="/home/root"
LOG_FILE="$HOME_DIR/logs/SYSLOG.ALS"

# SysInit Option 
# if install card includes sysinit.tar.gz extract it into /home/root
if [ -f "$1/afs_image/hwgen2/sysinit_2.tar.gz" ]; then
	echo "sysinitstarted" > $1/afs_image/hwgen2/sysinitstarted >> $LOG_FILE
	sync
	echo "Initializing default data from sysinit.tar.gz" >> $LOG_FILE
	tar -xzf $1/afs_image/hwgen2/sysinit_2.tar.gz -C $HOME_DIR
	rm -f $1/afs_image/hwgen2/sysinitstarted
	sync
fi

if [ "$(uname -r)" == "3.2.29-smp" ]; then
  echo "wificonfigstarted" > $1/afs_image/hwgen2/sysinitstarted >> $LOG_FILE
  CUR=$(pwd)

  cd "$1/afs_image/hwgen2"
  
  if [ ! -f /usr/lib/libprotobuf.so.9.0.1 ]; then
    echo "Installing libprotobuf" >> $LOG_FILE
    cp libprotobuf.so.9.0.1 /usr/lib
    ln -s /usr/lib/libprotobuf.so.9.0.1 /usr/lib/libprotobuf.so.9
    echo "Completed installing libprotobuf." >> $LOG_FILE
  fi

  if [ ! -f /usr/lib/libunistring.so.2 ]; then
    echo "Installing libunistring" >> $LOG_FILE
    cp libunistring.so.2 /usr/lib
    echo "Completed installing libunistring." >> $LOG_FILE
  fi

###############################################################################
# Please note: the wifi.0.1 file is meant to be a permenent version number
# that allows us to know which script to run. If we need to make changes to this
# in the future, a check for $HOME_DIR/logs/wifi.A.B should be added after all
# existing scripts.
###############################################################################
  cd wifi
  if [ ! -f $HOME_DIR/logs/wifi.0.1 ]; then
    echo "installed" > $HOME_DIR/logs/wifi.0.1
    echo "Installing wifi drivers and startup scripts." >> $LOG_FILE
    ./wifi.0.1.sh
    echo "WIFI 0.1 Installation completed." >> $LOG_FILE
  fi

###############################################################################
# Verion 0.2 was a development branch, and is skipped to ensure that ALL units
# get a functional version of these routines.
###############################################################################
  if [ ! -f $HOME_DIR/logs/wifi.0.3 ]; then
    echo "Installing Wifi Setup version 0.3" >> $LOG_FILE
    ./wifi.0.2.sh
    echo "WIFI 0.3 Installation Completed." >> $LOG_FILE
  fi

###############################################################################
# Verion 0.3 attempted to disable the dns functionality of dnsmasq, thus enabling
# the ipad to pull data off the cellular network when present. We are removing this.
# In version 4 until further testing can be completed.
###############################################################################
  if [ ! -f $HOME_DIR/logs/wifi.0.4 ]; then
    echo "Installing Wifi Setup version 0.4" >> $LOG_FILE
    cp dnsmasq.conf /etc
    echo "0.4" >> $HOME_DIR/logs/wifi.0.4
    echo "Wifi 0.4 Installation Complete." >> $LOG_FILE
  fi

###############################################################################
# Verion 0.5 
###############################################################################
  if [ ! -f $HOME_DIR/logs/wifi.0.5 ]; then
    echo "Installing Wifi Setup version 0.5" >> $LOG_FILE
    ./wifi.0.3.sh
    echo "WIFI 0.5 Installation Completed." >> $LOG_FILE
  fi


	rm -f $1/afs_image/hwgen2/sysinitstarted
  cd "$CUR"
fi
