#!/bin/bash
KVER=$(uname -r) 
MODDESTDIR=/lib/modules/$KVER/kernel/drivers/net/wireless

###############################################################################
# This installs the rtl8188eu driver, which our driver depends upon for some
# mystical reason that I haven't been able to fathom. It won't work without
# this (attempted).
###############################################################################
install -p -m 644 8188eu.ko $MODDESTDIR
modprobe -r 8188eu
echo "blacklist r8188eu" > /etc/modprobe.d/50-8188eu.conf
cp rtl8188eufw.bin /lib/firmware
depmod -a $KVER
mkdir -p /lib/firmware/rtlwifi
cp -n rtl8188eufw.bin /lib/firmware/rtlwifi

###############################################################################
# This installs the actual 8192cu driver. The one what works as an access 
# point. 
###############################################################################
install -p -m 644 8192cu.ko $MODDESTDIR
depmod -a $KVER

###############################################################################
#
###############################################################################
echo "blacklist r8188eu" > /etc/modprobe.d/blacklist.conf
echo "blacklist rtl8192cu" >> /etc/modprobe.d/blacklist.conf

###############################################################################
# Here we install the other applications neccisary to get an access point 
# working.
###############################################################################
cp dnsmasq /usr/local/bin
cp hostapd /usr/local/bin
cp hostapd_cli /usr/local/bin
chmod +x /usr/local/bin/dnsmasq
chmod +x /usr/local/bin/hostapd
chmod +x /usr/local/bin/hostapd_cli

###############################################################################
# Here we copy the hostapd configuration file. 
###############################################################################
if [ ! -d /etc/hostapd ]; then
  mkdir /etc/hostapd
fi
cp hostapd.conf /etc/hostapd

###############################################################################
# Here we copy the dnsconfig file
###############################################################################
if [ ! -d /var/lib/misc ]; then
  mkdir /var/lib/misc         # Needed to keep dnsmasq happy.
fi
cp dnsmasq.conf /etc

###############################################################################
# Now the biggie, /etc/local/sbin/hostapd-start
###############################################################################
RC_LOCAL=/etc/rc.d/rc.local
cp $RC_LOCAL /home/root/rc.local.bak
echo "#!/bin/sh -e" > $RC_LOCAL
echo "echo Running rc.local" >> $RC_LOCAL
echo "cd /home/root" >> $RC_LOCAL
echo "if [ -f /media/AFS_DATA/afs_repair.sh ]; then" >> $RC_LOCAL
echo "  chmod +x /media/AFS_DATA/afs_repair.sh" >> $RC_LOCAL
echo "  /media/AFS_DATA/afs_repair.sh" >> $RC_LOCAL
echo "  mv /media/AFS_DATA/afs_repair.sh /media/AFS_DATA/afs_repaid.sh.old" >> $RC_LOCAL
echo "fi" >> $RC_LOCAL
echo "if [ -d /sys/ ]; then" >> $RC_LOCAL
echo "  /sbin/ifconfig wlan0 up 192.168.10.1 netmask 255.255.255.0" >> $RC_LOCAL
echo "  /usr/local/bin/dnsmasq" >> $RC_LOCAL
echo "  /usr/sbin/iptables --flush" >> $RC_LOCAL
echo "  /usr/sbin/iptables --table nat --flush" >> $RC_LOCAL
echo "  /usr/sbin/iptables --delete-chain" >> $RC_LOCAL
echo "  /usr/sbin/iptables --table nat --delete chain" >> $RC_LOCAL
echo "  /usr/sbin/iptables --table nat --append POSTROUTING --out-interface lo -j MASQUERADE" >> $RC_LOCAL
echo "  /usr/sbin/iptables --append FORWARD --in-interface wlan0 -j ACCEPT" >> $RC_LOCAL
echo "  /sbin/sysctl -w net.ipv4.ip_forward=1" >> $RC_LOCAL
echo "  /usr/local/bin/hostapd -B /etc/hostapd/hostapd.conf 1> /dev/null" >> $RC_LOCAL
echo "fi" >> $RC_LOCAL
echo "/usr/bin/xinit ./AFSMON.AFE" >> $RC_LOCAL
chmod +x $RC_LOCAL
